using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page, ICallbackEventHandler
    {
        private string returnString;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));

                LayerOverlay newOverlay = new LayerOverlay("NewOverlay");
                newOverlay.IsBaseOverlay = false;
                newOverlay.Layers.Add(worldLayer);
                Map1.CustomOverlays.Add(newOverlay);

            }
        }

        #region ICallbackEventHandler Members

        public string GetCallbackResult()
        {
            return returnString;
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            returnString = "NewOverlay";

            LayerOverlay newOverlay = (LayerOverlay)Map1.CustomOverlays[returnString];
            ShapeFileFeatureLayer worldLayer = newOverlay.Layers[0] as ShapeFileFeatureLayer;
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Red));

        }

        #endregion
    }
}
